/*
 * Copyright (c) 2001-2006
 *     DecisionSoft Limited. All rights reserved.
 * Copyright (c) 2004-2006
 *     Progress Software Corporation. All rights reserved.
 * Copyright (c) 2004-2006
 *     Oracle. All rights reserved.
 *
 * See the file LICENSE for redistribution information.
 *
 * $Id: FunctionPosition.hpp,v 1.10 2007/02/07 12:13:05 jpcs Exp $
 */

/*

   Position function

*/

#ifndef _FUNCTIONPOSITION_HPP
#define _FUNCTIONPOSITION_HPP

#include <xqilla/ast/XQFunction.hpp>

/** Position function*/
class XQILLA_API FunctionPosition : public XQFunction
{
public:
  static const XMLCh name[];
  static const unsigned int minArgs;
  static const unsigned int maxArgs;

  FunctionPosition(const VectorOfASTNodes &args, XPath2MemoryManager* memMgr);
  
  virtual ASTNode* staticResolution(StaticContext *context);
  virtual ASTNode *staticTyping(StaticContext *context);

  Sequence createSequence(DynamicContext* context, int flags=0) const;
};

#endif // _FUNCTIONPOSITION_HPP



